'paint random and sinusgraph
dim array(628) as integer
dim n as integer

object myform as form
  center
  width=640
  height=400
  caption="Demo of painting a graph"
  object calcsin as button
    caption="Calculate sine values"
    width=150
    onclick=calcsin_click
  end object
  object calcrandom as button
    caption="Calculate random values"
    width=150
    left=160
    onclick=calcrandom_click
  end object
  object paintline as button
    width=150
    caption="Paint with line"
    top=30
    onclick=paintline_click
  end object
  object paintpset as button
    onclick=paintpset_click
    width=150
    left=160
    top=30
    caption="Paint with pset"
  end object
  object img as image
    width=628
    height=250
    top=60
  end object
  showmodal
end object

sub calcsin_click
  For n=1 to 628
    array(n)=sin(n/100)*100+128
  next n
end sub

sub calcrandom_click
  for n=1 to 628
    array(n)=rnd(100)+128
  next n
end sub

sub eraseimg
  const bkcolor=rgb(200,200,170)
  img.canvas.rectangle(0,0,img.width,img.height,0)
  img.canvas.fill(2,2,bkcolor,0)
end sub

sub paintline_click
  dim tempval as integer
  eraseimg
  'set first point
  tempval=array(1)
  img.canvas.line(1,tempval,1,tempval,255)
  'draw the lines
  for n= 2 to 628
    tempval=array(n)
    img.canvas.lineto(n,tempval,255)
  next n
end sub

sub paintpset_click
  dim tempval as integer
  eraseimg
  'draw the lines
  for n= 1 to 628
    tempval=array(n)
    img.canvas.pset(n,tempval,255)
  next n
end sub