
''microsoft for more info:
''http://msdn.microsoft.com/en-us/library/windows/desktop/ms724381(v=vs.85).aspx

record SYSTEM_INFO
  dwOemID As Long
  dwPageSize As Long
  lpMinimumApplicationAddress As Long
  lpMaximumApplicationAddress As Long
  dwActiveProcessorMask As Long
  dwNumberOrfProcessors As Long
  dwProcessorType As Long
  dwAllocationGranularity As Long
  wprocessorlevel as word
  wProcessorRevision as word
End record

Declare SystemInfo as "GetSystemInfo" of "kernel32"
  Info As SYSTEM_INFO
End Declare

systeminfo.execute

print "The processor architecture of the installed operating system :"
select case systeminfo.info.dwOemID
  case 9:print "PROCESSOR_ARCHITECTURE_AMD64"
  case 6:print "PROCESSOR_ARCHITECTURE_IA64"
  case 0:print "PROCESSOR_ARCHITECTURE_INTEL"
  case &hffff:print "PROCESSOR_ARCHITECTURE_UNKNOWN"
end select

print
print "A pointer to the lowest memory address accessible to applications and dynamic-link libraries (DLLs):"
print systeminfo.info.lpMinimumApplicationAddress

print
print "A pointer to the highest memory address accessible to applications and DLLs:"
print systeminfo.info.lpMaximumApplicationAddress

print
print "The number of logical processors in the current group:"
print systeminfo.info.dwNumberOrfProcessors

print
print "the type of processor:"
select case systeminfo.info.dwProcessorType
  case 386:print "PROCESSOR_INTEL_386"
  case 486:print "PROCESSOR_INTEL_486"
  case 586:print "PROCESSOR_INTEL_PENTIUM"
  case 2200:print "PROCESSOR_INTEL_IA64"
  case 8664:print "PROCESSOR_AMD_X8664"
end select

print
print "The architecture-dependent processor level:"
select case systeminfo.info.wprocessorlevel
  case 7:print "PF_3DNOW_INSTRUCTIONS_AVAILABLE"
  case 16:print "PF_CHANNELS_ENABLED"
  case 2:print "PF_COMPARE_EXCHANGE_DOUBLE"
  case 14:print "PF_COMPARE_EXCHANGE128"
  case 15:print "PF_COMPARE64_EXCHANGE128"
  case 1:print "PF_FLOATING_POINT_EMULATED"
  case 0:print "PF_FLOATING_POINT_PRECISION_ERRATA"
  case 3:print "PF_MMX_INSTRUCTIONS_AVAILABLE"
  case 12:print "PF_NX_ENABLED"
  case 9:print "PF_PAE_ENABLED"
  case 8:print "PF_RDTSC_INSTRUCTION_AVAILABLE"
  case 20:print "PF_SECOND_LEVEL_ADDRESS_TRANSLATION"
  case 13:print "PF_SSE3_INSTRUCTIONS_AVAILABLE"
  case 21:print "PF_VIRT_FIRMWARE_ENABLED"
  case 6:print "PF_XMMI_INSTRUCTIONS_AVAILABLE"
  case 10:print "PF_XMMI64_INSTRUCTIONS_AVAILABLE"
  case 17:print "PF_XSAVE_ENABLED"
end select

print
print "strike a key when ready"
while inkey$="":wend
  
