object myform as form
  caption="sort and search"
  object list as richedit
    height=myform.clientheight-30
    scrollbars=ssvertical
    hidescrollbars=false
  end object
  object sort as button
    onclick=sort_click
    caption="Sort"
    top=list.height
  end object
  object search as button
    caption="Search"
    top=sort.top
    left=sort.width
    enabled=false
    onclick=search_click
  end object
  object searchtext as edit
    top=search.top
    left=sort.width+search.width
  end object
end object

'fill in some data
dim c as integer,str as string
for c=1 to 100
  str=str+chr$(rnd(25)+65)
  str=str+chr$(rnd(25)+65)
  str=str+chr$(rnd(25)+65)
  str=str+chr$(rnd(25)+65)
  str=str+chr$(rnd(25)+65)+chr$(13)+chr$(10)
next c
list.text=str

'fill in search text
searchtext.text=list.line(50)

myform.showmodal

sub quicksort(first as integer,last as integer)
  'This is a semi recursive sub with a stack
  dim i as integer,j as integer
  dim mid as integer,A as string,B as string
  dim compare as string
  dim stack(100) as integer
  dim pointer as integer
  i=first
  j=last
  mid=(i+j)/2
  compare=list.line(mid)
  while i<=j
    while list.line(i)<compare
      inc(i)
    wend
    while list.line(j)>compare
      dec(j)
    wend
    if i<=j then 
      'swap values
       A=list.line(I)
       B=list.line(J)
       list.line(J)=A
       list.line(I)=B
       inc(i)
       dec(j)
     end if
   wend
   'push i,last
   stack(pointer)=i
   stack(pointer+1)=last
   pointer=pointer+2
   if j>first then quicksort(first,j)
   'pop i,last
   pointer=pointer-2
   i=stack(pointer)
   last=stack(pointer+1)
   if i<last then quicksort(i,last)
end sub

sub sort_click
  list.lock
  quicksort(0,99)
  list.unlock
  search.enabled=true
end sub

sub binsearch(item as string,from as integer,towards as integer)
  dim left as integer,right as integer
  dim stopnow as boolean,middle as integer
  left=from
  right=towards
  stopnow=false
  while stopnow=false
    middle=(left+right)/2
    if item<list.line(middle) then 
      right=middle-1
    else
      left=middle+1
    end if
    if item=list.line(middle) or left>right then stopnow=true
  wend
  if item=list.line(middle) then
    'found
    showmessage "found at line "+str$(middle)
  else
    showmessage "not found"
  end if
end sub

sub search_click
  binsearch(searchtext.text,0,99)
end sub