'=====MAIN LED ROUTINES==============
'=COLORS: RED GREEN AND BLUE        =   
'=METHODS: LEDON(IMAGE.CANVAS,COLOR)=  
'=         LEDOFF(IMAGE.CANVAS)     =
'====================================

const blue=rgb(0,0,255)
const green=rgb(0,200,0)
const red=rgb(255,0,0)

sub led
  dim bmp as bitmap
  dim effect as integer
  dim c as integer,size as byte
  dim on as boolean
  size=8
  if on=false then effect=rgb(120,120,120)
  bmp.width=size*2
  bmp.height=size*2
  bmp.transparentcolor=&hffffff
  bmp.transparent=true
  bmp.canvas.circle(size,size,size,0)
  bmp.canvas.fill(size,size,effect,0)
  for c=size-4 to size
    bmp.canvas.line(c/2,c,c,c/2,&hffffff)
  next c
end sub

sub ledon(s as canvas,effect as integer)
  led.effect=effect
  led.on=true
  led
  s.draw(0,0,led.bmp)
end sub

sub ledoff(s as canvas)
  led.on=false
  led
  s.draw(0,0,led.bmp)
end sub


'=======Example prograM======
object myform as form
  object led1 as image
    left=10
    top=10
    transparent=true
  end object
  object led2 as image
    left=10
    top=30
    transparent=true
  end object  
end object

ledon(led1.canvas,red)
ledoff(led2.canvas)
myform.showmodal
















