''written by marco for fnxbasic
''Program to restart an exe after a speciefied time
''The program shut down the executable and restarts it
appicon="restarter.ico"

dim i as inifile
dim pid as integer

Declare Wait as "WaitForSingleObject" of "kernel32"
  Handle As integer
  Milliseconds As integer
end declare

Declare Terminate as "TerminateProcess" of "kernel32"
  Process As integer
  ExitCode As integer
end declare

object f as form
  caption="Program restarter"
  center
  width=500
  height=100
  object l1 as label
    top=3
    caption="Program to run: "
  end object
  object e as edit
    top=2
    width=325
    left=l1.width
  end object
  object b as button
    left=l1.width+e.width
    caption="Browse"
    onclick=browse_click
  end object
  object l2 as label
    caption="Restart program every "
    top=42
  end object 
  object c as combobox
    left=l2.width
    width=50
    top=40
  end object  
  object l3 as label
    caption="  hour"
    top=42
    left=c.width+l2.width 
  end object  
   object start as button
    caption="Start program"
    left=l3.left+l3.width+100
    top=40
    onclick=start_click
  end object
end object

dim t as integer
for t=1 to 24
  c.additem(str$(t))
next t

if fileexists(exepath+"restarter.ini")=true then
  i.open(exepath+"restarter.ini")
  e.text=i.readstr("general\programfile")
  c.text=i.readstr("general\startEvery")
else
  c.text="1"
end if

f.showmodal

sub start_click
  dim curtime as integer,usedtime as double
  if e.text="" then showmessage "No execute selected!"
  ''write to inifile
  i.open(exepath+"restarter.ini")
  i.writestr("general\programfile\"+e.text)
  i.writestr("general\startEvery\"+c.text)
  do
    ''calculate time
    curtime=val(mid$(time$,4,2))*60+val(right$(time$,2))
    curtime=3600-curtime
    if curtime<600 then curtime=curtime+3600
    curtime=(val(c.text)-1)*3600+curtime
    f.windowstate=wsminimized
    ''start up program
    wait.milliseconds=curtime*1000
    pid=shell(e.text);
    print "program started at "+time$
    wait.handle=pid
    usedtime=timer
    wait.execute
    f.windowstate=wsnormal
    print "shut down program at "+time$
    terminate.process=pid
    terminate.execute
    if timer-usedtime<curtime-5 then
      print "program aborted by user at "+time$
      exit do
    end if
  loop
end sub

sub browse_click
  dim file as filedialog
  file.buttontext="Select"
  file.caption="Select program to restart"
  File.filter="Executables *.exe|*.exe"
  file.show
  e.text=file.filename
end sub










