'simple year notebook example

dim dbase as randomfile
dim recnr as integer
dim modified as boolean

record day
  data as string * 3000
end record
'remove this file from the folder to build a new one.
if fileexists("yearbook.txt")=false then
  'create database
  dim c as integer
  dbase.open("yearbook.txt")
  dbase assign(day)
  for c=0 to 365
    day.data="This is day "+str$(c)+" add some text"
    dbase.append
  next c
else
  'open existing database
  dbase.open("yearbook.txt")
  dbase assign(day)
end if

object f as form
  center
  caption="Yearbook"
  object r as richedit
    readonly=false
    height=f.clientheight
    size=3000
    onkeypress=setmodified
  end object
  
  object prev as button
    left=r.width+20
    width=20
    caption="<"
    font.bold=true
    onclick=prevnext
  end object
  
  object nxt as button
    left=r.width+70
    width=20
    caption=">"
    font.bold=true
    onclick=prevnext
  end object
  
  object currecnr as edit
    text=str$(1)
    top=2
    left=r.width+40
    width=30
    onchange=savecurrent
  end object
end object

dbase.get(val(currecnr.text))
r.text=rtrim$(day.data)
recnr=1
f.showmodal

sub setmodified
  modified=true
end sub

sub savecurrent
  if modified=true then
    'save to dbase
    day.data=r.text
    dbase.put(recnr)
  end if
  if currecnr.text="" then exit sub
  if val(currecnr.text)>365 then
    currecnr.text=str$(365)
  else
    if val(currecnr.text)<1 then
      currecnr.text=str$(1)
    end if
  end if
  'load from dbase
  dbase.get(val(currecnr.text))
  r.text=rtrim$(day.data)
  recnr=val(currecnr.text)
  modified=false
end sub

sub prevnext(sender as button)
  dim recnrtemp as integer
  recnrtemp=val(currecnr.text)
  if sender.caption="<" then dec(recnrtemp) else inc(recnrtemp)
  currecnr.text=str$(recnrtemp)
end sub

dbase.close